const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_movements = sequelize.define(
    'inventory_movements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

movement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"in",


"out",


"adjustment",


"transfer_out",


"transfer_in"

        ],

      },

quantity: {
        type: DataTypes.INTEGER,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

reference_type: {
        type: DataTypes.TEXT,
      
      

      },

reference_number: {
        type: DataTypes.TEXT,
      
      

      },

moved_at: {
        type: DataTypes.DATE,
      
      

      },

note: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_movements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.inventory_movements.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.users, {
      as: 'performed_by',
      foreignKey: {
        name: 'performed_byId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_movements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_movements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_movements;
};


